(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations/browser'), require('@angular/core'), require('ngx-window-token'), require('@angular/platform-browser/animations')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/animations/browser', '@angular/core', 'ngx-window-token', '@angular/platform-browser/animations'], factory) :
	(factory((global.ngx = global.ngx || {}, global.ngx.noAnimation = global.ngx.noAnimation || {}),global._angular_animations_browser,global.ng.core,global.ngxWindowToken,global._angular_platformBrowser_animations));
}(this, (function (exports,_angular_animations_browser,_angular_core,ngxWindowToken,_angular_platformBrowser_animations) { 'use strict';

/**
 * @param {?} win
 * @param {?} browserDetectService
 * @param {?=} config
 * @return {?}
 */
function animationFactory(win, browserDetectService, config) {
    var /** @type {?} */ isSupported = browserDetectService.isBrowserSupport(win.navigator.userAgent);
    if (!isSupported || (config && config.disable)) {
        return new _angular_animations_browser.ɵNoopAnimationDriver();
    }
    else {
        return new _angular_animations_browser.ɵWebAnimationsDriver();
    }
}

var BrowserDetectService = (function () {
    /**
     * @param {?} window
     */
    function BrowserDetectService(window) {
        this.window = window;
    }
    /**
     * @param {?} ua
     * @return {?}
     */
    BrowserDetectService.prototype.isBrowserSupport = function (ua) {
        // tslint:disable-next-line:no-string-literal
        if (!!this.window['chrome'] && !!this.window['chrome']['webstore']) {
            return true;
        }
        else if (ua.indexOf('MSIE') !== -1) {
            return ua.indexOf('MSIE 10') !== -1; // filter out all IE but IE10
        }
        else if (ua.indexOf('Edge') !== -1 || ua.indexOf('Trident') !== -1) {
            return true; // IE11 and Edge
        }
        else if (ua.indexOf('Firefox') !== -1) {
            var /** @type {?} */ match = /((?!Gecko.+)Firefox|Gecko(?!.+Firefox))(?: |\/)([\d]+)/.exec(ua);
            var /** @type {?} */ ver = +match[2];
            return !!match[1] && !isNaN(ver) && ver >= 27; // Firefox 27+
        }
        else if (ua.indexOf('Safari') !== -1) {
            var /** @type {?} */ match = /(?:iPod|iPhone|iPad).+Version\/(\d+\.\d+).*Safari/.exec(ua); // iOS safari 7.1+
            var /** @type {?} */ ver = match ? +match[1] : NaN;
            if (!isNaN(ver)) {
                return ver >= 7.1;
            }
            match = /Version\/(\d+)\.\d+(?:\.\d+)?.*Safari/.exec(ua); // OS X Safari 9+
            ver = match ? +match[1] : 0;
            if (!isNaN(ver)) {
                return ver >= 9;
            }
        }
        return false;
    };
    return BrowserDetectService;
}());
BrowserDetectService.decorators = [
    { type: _angular_core.Injectable },
];
/**
 * @nocollapse
 */
BrowserDetectService.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [ngxWindowToken.WINDOW,] },] },
]; };

var CONFIG_TOKEN = new _angular_core.InjectionToken('config');
var BrowserSupportedAnimationsModule = (function () {
    function BrowserSupportedAnimationsModule() {
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    BrowserSupportedAnimationsModule.forRoot = function (config) {
        return {
            ngModule: BrowserSupportedAnimationsModule,
            providers: [
                BrowserDetectService,
                { provide: CONFIG_TOKEN, useValue: config },
                { provide: _angular_animations_browser.AnimationDriver, useFactory: animationFactory, deps: [ngxWindowToken.WINDOW, BrowserDetectService, CONFIG_TOKEN] }
            ]
        };
    };
    return BrowserSupportedAnimationsModule;
}());
BrowserSupportedAnimationsModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [_angular_platformBrowser_animations.BrowserAnimationsModule, ngxWindowToken.WindowTokenModule]
            },] },
];
/**
 * @nocollapse
 */
BrowserSupportedAnimationsModule.ctorParameters = function () { return []; };

exports.BrowserSupportedAnimationsModule = BrowserSupportedAnimationsModule;
exports.animationFactory = animationFactory;

Object.defineProperty(exports, '__esModule', { value: true });

})));
