import { animationFactory, CONFIG_TOKEN } from './';
import { BrowserDetectService } from './browser-detect.service';
import { AnimationDriver, ɵNoopAnimationDriver, ɵWebAnimationsDriver } from '@angular/animations/browser';
import { animate, Component, state, style, transition, trigger } from '@angular/core';
import { TestBed } from '@angular/core/testing';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { WindowTokenModule, WINDOW } from 'ngx-window-token';
var TestComponent = (function () {
    function TestComponent() {
    }
    return TestComponent;
}());
export { TestComponent };
TestComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'test-component',
                template: "<button (click)=\"show=!show\">Fly in</button><h1 [@flyInOut] *ngIf=\"show\">test</h1>",
                // tslint:disable-next-line:object-literal-sort-keys
                animations: [
                    trigger('flyInOut', [
                        state('in', style({ transform: 'translateX(0)' })),
                        transition('void => *', [
                            style({ transform: 'translateX(-100%)' }),
                            animate(100)
                        ]),
                        transition('* => void', [
                            animate(100, style({ transform: 'translateX(100%)' }))
                        ])
                    ])
                ]
            },] },
];
/**
 * @nocollapse
 */
TestComponent.ctorParameters = function () { return []; };
function TestComponent_tsickle_Closure_declarations() {
    /** @type {?} */
    TestComponent.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    TestComponent.ctorParameters;
    /** @type {?} */
    TestComponent.prototype.show;
}
/**
 * @param {?} mockedService
 * @param {?} mockedConfig
 * @return {?}
 */
function getFixture(mockedService, mockedConfig) {
    return TestBed.configureTestingModule({
        declarations: [TestComponent],
        imports: [
            BrowserAnimationsModule, WindowTokenModule
        ],
        providers: [
            { provide: BrowserDetectService, useValue: mockedService },
            { provide: CONFIG_TOKEN, useValue: mockedConfig },
            { provide: AnimationDriver, useFactory: animationFactory, deps: [WINDOW, BrowserDetectService, CONFIG_TOKEN] }
        ]
    }).createComponent(TestComponent);
}
describe('factory: animationFactory', function () {
    var /** @type {?} */ spy;
    var /** @type {?} */ config;
    var /** @type {?} */ fixture;
    var /** @type {?} */ animationDriver;
    var /** @type {?} */ browserDetectService;
    var /** @type {?} */ browserDetectServiceDouble;
    var /** @type {?} */ button;
    describe('if browser is not supported', function () {
        beforeEach(function () {
            // create a mocked service
            browserDetectServiceDouble = {
                isBrowserSupport: function (ua) { return false; }
            };
            fixture = getFixture(browserDetectServiceDouble, undefined);
            animationDriver = fixture.debugElement.injector.get(AnimationDriver);
            browserDetectService = fixture.debugElement.injector.get(BrowserDetectService);
            fixture.detectChanges();
        });
        it('isBrowserSupport should be false', function () {
            expect(browserDetectService.isBrowserSupport('')).toBeFalsy();
        });
        it('should use ɵNoopAnimationDriver', function () {
            expect(animationDriver instanceof ɵNoopAnimationDriver).toBeTruthy();
        });
    });
    describe('if browser is supported', function () {
        beforeEach(function () {
            // create a mock service
            browserDetectServiceDouble = {
                isBrowserSupport: function (ua) { return true; }
            };
            fixture = getFixture(browserDetectServiceDouble, undefined);
            animationDriver = fixture.debugElement.injector.get(AnimationDriver);
            browserDetectService = fixture.debugElement.injector.get(BrowserDetectService);
            fixture.detectChanges();
        });
        it('isBrowserSupport should be true', function () {
            expect(browserDetectService.isBrowserSupport('')).toBeTruthy();
        });
        it('should use ɵWebAnimationsDriver', function () {
            expect(animationDriver instanceof ɵWebAnimationsDriver).toBeTruthy();
        });
    });
    describe('if browser is supported, but set disable in config', function () {
        beforeEach(function () {
            // create a mock service
            browserDetectServiceDouble = {
                isBrowserSupport: function (ua) { return true; }
            };
            fixture = getFixture(browserDetectServiceDouble, { disable: true });
            animationDriver = fixture.debugElement.injector.get(AnimationDriver);
            browserDetectService = fixture.debugElement.injector.get(BrowserDetectService);
            fixture.detectChanges();
        });
        it('isBrowserSupport should be true', function () {
            expect(browserDetectService.isBrowserSupport('')).toBeTruthy();
        });
        it('should use ɵNoopAnimationDriver', function () {
            expect(animationDriver instanceof ɵNoopAnimationDriver).toBeTruthy();
        });
    });
});
//# sourceMappingURL=animation.factory.spec.js.map